#!/usr/bin/python
import sys
from espresso import irred_prods, dual_prods
from math import ceil

def intersect(px, py):
  assert len(px) == len(py)

  for vi in xrange(len(px)):
    if px[vi] == '0' and py[vi] == '1':
      return -1*(vi+1)
    if px[vi] == '1' and py[vi] == '0':
      return vi+1

  return None

## Compute the upper bound on circuit size.
prods = [ elt[0] for elt in map(lambda line: line.strip().split(), sys.stdin.readlines()) ]
duals = dual_prods(prods)

lat = [ [ repr(intersect(prods[ci], duals[ri])) for ci in xrange(len(prods)) ] for ri in xrange(len(duals)) ]
ws = [ max([len(lat[r][c]) for r in xrange(len(duals))]) for c in xrange(len(prods)) ]

for row in lat:
  print " | ".join([ " "*(ws[c] - len(row[c])) + row[c] for c in xrange(len(row))])
#print lat
