#!/usr/bin/python
import sys
from espresso import irred_prods, dual_prods
from math import ceil

## Compute the upper bound on circuit size.
#prods = [ elt[0] for elt in map(lambda line: line.strip().split(), sys.stdin.readlines()) ]
#duals = dual_prods(prods)

def get_bounds(prods, duals):
  plen = max([len(prod.replace("-","")) for prod in prods])
  dlen = max([len(prod.replace("-","")) for prod in duals])

## Compute the lower-bound, in an incredibly naive way.
  def lb_feasible(v, y, r, c):
    if r <= 2 or c <= 1:
      if v > r:
        return False
    else:
      if v > 3*ceil(float(r-2)/2)*ceil(float(c)/2) + (2 + (-1)**r + (-1)**c)/2:
        return False

    if r <= 3 or c <= 2:
      if y > c:
        return False
    else:
      if y > 2*ceil(float(r)/2)*ceil(float(c-2)/2) + (2 + (-1)**r + (-1)**c)/2:
        return False
    return True

## Find the smallest area with a feasible configurations
  lb = 1
  while True:
    cs = [ (r, lb/r) for r in xrange(1, lb+1) if (lb % r) == 0 ]
    if any(map(lambda (r, c) : lb_feasible(plen, dlen, r, c), cs)):
      break
    lb += 1

  #ub_riedel = "({0}x{1})".format(len(duals), len(prods))
  ub_riedel = (len(duals), len(prods))

  w_ub = 2*len(prods) - 1
  h_ub = plen
  #ub_build = "({0}x{1})".format(h_ub, w_ub)
  ub_build = (h_ub, w_ub)

  return len(prods[0]), ub_riedel, ub_build, lb

if __name__ == "__main__":
  prods = [ elt[0] for elt in map(lambda line: line.strip().split(), sys.stdin.readlines()) ]
  duals = dual_prods(prods)
  (vs, ub_r, ub_b, lb) = get_bounds(prods, duals)
  #print len(prods[0]), ub_riedel, ub_build, lb
  print vs, "({0}x{1})".format(ub_r[0], ub_r[1]), "({0}x{1})".format(ub_b[0], ub_b[1]), lb
