import sys
import subprocess
from tempfile import TemporaryFile
import paths

def irred_prods(prods):
  prodfile = TemporaryFile()
  print >> prodfile, ".i {0}".format(len(prods[0]))
  print >> prodfile, ".o 1"
  print >> prodfile, ".p {0}".format(len(prods))
  for prod in prods:
    print >> prodfile, prod, "1"

  resfile = TemporaryFile()
  prodfile.seek(0)
  subprocess.call([paths.espresso, "-S1"], stdin = prodfile, stdout = resfile)
  resfile.seek(0)

  out_prods = []
  out_vs = set()
  for line in resfile.readlines():
    line = line.strip()
    if line.startswith('.'):
      pass
    else:
      [pre, suf] = line.split()
      assert suf == '1'
      out_prods.append(pre)
      for ci in xrange(len(pre)):
        if pre[ci] != '-':
          out_vs |= { ci }
  out_vs = sorted(list(out_vs))
  return [ "".join([prod[vi] for vi in out_vs]) for prod in out_prods ]

def dual_prods(prods):
  prodfile = TemporaryFile()
  print >> prodfile, ".i {0}".format(len(prods[0]))
  print >> prodfile, ".o 1"
  print >> prodfile, ".p {0}".format(len(prods))
  for prod in prods:
    print >> prodfile, prod, "1"

  resfile = TemporaryFile()
  prodfile.seek(0)
  subprocess.call([paths.espresso, "-S1", "-or"], stdin = prodfile, stdout = resfile)
  resfile.seek(0)

  out_prods = []
  out_vs = set()
  for line in resfile.readlines():
    line = line.strip()
    if line.startswith('.'):
      pass
    else:
      [pre, suf] = line.split()
      assert suf == '0'
      out_prods.append(pre)
      for ci in xrange(len(pre)):
        if pre[ci] != '-':
          out_vs |= { ci }
  out_vs = sorted(list(out_vs))
  return [ "".join([prod[vi] for vi in out_vs]) for prod in out_prods ]
