## Some quick option parsing stuff.

# Takes a list of arguments, a spec of form { string -> (attr, string -> a) }
# and an option class, returning the list of unmatched arguments.
def setopt(attr, val):
  return (None, lambda opts: setattr(opts, attr, val))

def parse_opts(args, spec, opts):
  ii = 0
  jj = 0
  while ii < len(args):
    if args[ii] in spec:
      (attr, fun) = spec[args[ii]]
      if attr is None:
        fun(opts)
        ii += 1
      else:
        setattr(opts, attr, fun(args[ii+1]))
        ii += 2
    else:
      args[jj] = args[ii]
      jj += 1
      ii += 1
  return args[:jj]
